function webdav_changeProperties()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_XML = _function_argument("xml")
      

      
      
      VAR_WEBDAV_FOLDER_PATH = _function_argument("file path")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_post_no_redirect(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_FOLDER_PATH, ["data", VAR_WEBDAV_XML], {"content-type":"custom/" + ("application/x-www-form-urlencoded"), "encoding":("UTF-8"), "method":("PROPPATCH"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER)})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content("auto")
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

function webdav_deletePath()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_FOLDER_PATH = _function_argument("file path")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      VAR_WEBDAV_AUTH_HEADER = base64_encode(VAR_WEBDAV_AUTH_STRING)
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_get2(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_FOLDER_PATH,{method:("DELETE"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER)})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content("auto")
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

function webdav_moveFile()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_MOVE_PATH = _function_argument("path to move")
      

      
      
      VAR_WEBDAV_FILE_PATH = _function_argument("path to file")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      VAR_WEBDAV_AUTH_HEADER = base64_encode(VAR_WEBDAV_AUTH_STRING)
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_get2(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_FILE_PATH,{method:("MOVE"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER + "\r\nDestination: /" + VAR_WEBDAV_MOVE_PATH)})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content("auto")
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

function webdav_copyFile()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_COPY_PATH = _function_argument("path to copy file")
      

      
      
      VAR_WEBDAV_FILE_PATH = _function_argument("path to file")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      VAR_WEBDAV_AUTH_HEADER = base64_encode(VAR_WEBDAV_AUTH_STRING)
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_get2(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_FILE_PATH,{method:("COPY"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER + "\r\nDestination: /" + VAR_WEBDAV_COPY_PATH)})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content("auto")
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

function webdav_getFile()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_ENCODING = _function_argument("responce encoding")
      

      
      
      VAR_WEBDAV_FILE_PATH = _function_argument("file path")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      VAR_WEBDAV_AUTH_HEADER = base64_encode(VAR_WEBDAV_AUTH_STRING)
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_get2(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_FILE_PATH,{method:("GET"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER)})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content(VAR_WEBDAV_ENCODING)
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

function webdav_uploadFile()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_PATH_FOR_UPLOAD = _function_argument("path for upload")
      

      
      
      VAR_WEBDAV_PATH_TO_FILE = _function_argument("path to file")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      VAR_WEBDAV_AUTH_HEADER = base64_encode(VAR_WEBDAV_AUTH_STRING)
      

      
      
      VAR_FILE_CONTENT = native("filesystem", "readfile", JSON.stringify({value: VAR_WEBDAV_PATH_TO_FILE,base64:true,from:0,to:0}))
      

      
      
      VAR_WEBDAV_ETAG = md5(VAR_FILE_CONTENT)
      VAR_WEBDAV_SHA256 = CryptoJS.SHA256(VAR_FILE_CONTENT).toString()
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_post_no_redirect(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_PATH_FOR_UPLOAD, ["data", "file://" + VAR_WEBDAV_PATH_TO_FILE], {"content-type":"custom/" + ("application/binary"), "encoding":("UTF-8"), "method":("PUT"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER + "\r\nTransfer-Encoding: chunked\r\nEtag: " + VAR_WEBDAV_ETAG + "\r\nSha256: " + VAR_WEBDAV_SHA256 + "\r\nExpect: 100-continue")})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content("auto")
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

function webdav_fileAndDirectoryProperties()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_FOLDER_PATH = _function_argument("folder path")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      VAR_WEBDAV_AUTH_HEADER = base64_encode(VAR_WEBDAV_AUTH_STRING)
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_get2(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_FOLDER_PATH,{method:("PROPFIND"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER)})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content("auto")
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

function webdav_createFolder()
   {
   
      
      
      VAR_WEBDAV_HOST = _function_argument("host")
      

      
      
      VAR_WEBDAV_FOLDER_PATH = _function_argument("folder path")
      

      
      
      VAR_WEBDAV_AUTH_STRING = _function_argument("auth string")
      

      
      
      VAR_WEBDAV_AUTH_HEADER = base64_encode(VAR_WEBDAV_AUTH_STRING)
      

      
      
      _call(function()
      {
      _on_fail(function(){
      VAR_LAST_ERROR = _result()
      VAR_ERROR_ID = ScriptWorker.GetCurrentAction()
      VAR_WAS_ERROR = false
      _break(1,true)
      })
      CYCLES.Current().RemoveLabel("function")
      
         
         
         _switch_http_client_main()
         http_client_get2(VAR_WEBDAV_HOST + "/" + VAR_WEBDAV_FOLDER_PATH,{method:("MKCOL"),headers:("Authorization: Basic " + VAR_WEBDAV_AUTH_HEADER)})!
         

      },null)!
      

      
      
      _if(VAR_WAS_ERROR,function(){
      
         
         
         _function_return(VAR_LAST_ERROR)
         

      })!
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_BODY = http_client_encoded_content("auto")
      

      
      
      _switch_http_client_main()
      VAR_WEBDAV_RESULT_STATUS = http_client_status()
      

      
      
      VAR_WEBDAV_RESULT = {
      "status":VAR_WEBDAV_RESULT_STATUS,
      "body":VAR_WEBDAV_RESULT_BODY
      };
      

      
      
      _function_return(VAR_WEBDAV_RESULT)
      

   }
   

